#include "misc.h"

void ConfigUARTSpeed9600(void)
{
    int udiv0;
    //GP1CON = 0x11;
    switch (POWCON & 0x03) {
        case 0: udiv0 = 0x88; break;  // HCLK = 41.78MHz; UART 9600 kbps
        case 1: udiv0 = 0x44; break;  // HCLK = 20.89MHz; UART 9600 kbps
        case 2: udiv0 = 0x22; break;  // HCLK = 10.45MHz; UART 9600 kbps
        case 3: udiv0 = 0x11; break;  // HCLK =  5.22MHz; UART 9600 kbps
        default:udiv0 = 0x88; break;  // HCLK = 41.78MHz; UART 9600 kbps
    }

    COMCON0 = 0x80;
    COMDIV0 = udiv0;
    COMDIV1 = 0x0;
    COMCON0 = 0x03; 
    COMDIV2 = 0x0;
}	

void wait (void)  {                        /* wait function */
  unsigned long i;                         /* Delay var */

  for (i = 0; i < 100000; )  {             /* Delay for 10000 Counts */
    i++;
  }
}

void wait2(void)  {                        /* wait function */
  unsigned long i;                         /* Delay var */

  for (i = 0; i < 500000; )  {             /* Delay for 50000 Counts */
    i++;
  }
}

void gpio_led_on(void)
{
  GP4DAT = 0x04000000;
}

void gpio_led_off(void)
{
  GP4DAT = 0x04040000;
}

void i2c_to_edid()
{
	GP2DAT = 0x01000000; // Setting GP2 P2.0 = LOW
}

void i2c_to_hdmirx()
{
	GP2DAT = 0x01010000; // Setting GP2 P2.0 = HIGH
}

char get_uart_char() {
	while(!(0x01==(COMSTA0 & 0x01)));
	return COMRX;
}

void delay (int length)
{
	while (length >0)
    	length--;
}

